/** Un conto bancario positivo ha un saldo che pu&ograve;
    essere modificato da depositi e prelievi. Non pu&ograve; essere
    prelevato un importo maggiore di quello presente.
    */
public class PositiveBankAccount  {
  /** Costruisce un conto bancario con saldo
      uguale a zero
      */
  public PositiveBankAccount() {
    saldo = 0.0;
  }

  /** Costruisce un conto bancario con un 
      saldo assegnato
      @param initialBalance il saldo iniziale
      */
  public PositiveBankAccount(double initialBalance) {
    saldo = initialBalance;
  }

  /** Versa denaro nel conto bancario
      @param amount l'importo da versare
      */
  public void deposit(double amount) {
    saldo = saldo + amount;
  }

  /** Preleva denaro dal conto bancario. Se la cifra richiesta supera
      la disponibilit&agrave; il prelievo non va a buon fine e viene
      applicata una penale.
      @param amount l'importo da prelevare
      */
  public void withdraw(double amount) {
    double nuovoSaldo = saldo - amount;
    if ( nuovoSaldo >= 0 )
      saldo = nuovoSaldo;
    else {
      System.out.println("Importo Richiesto Non Disponibile");
      /* Esempio di dichiarazione di variabile in un nuovo blocco: non posso
         usare lo stesso nome gi usato in un blocco pi esterno della stessa
         attivazione. La nuova variabile scompare alla chiusura del blocco */
      { // Nuovo Blocco
      // double nuovoSaldo = saldo - PENALTY; Errore! Non posso usare lo stesso nome
      double saldoConPenale = saldo - PENALTY;
      saldo = saldoConPenale;
      System.out.println("Penale di " + PENALTY + " euro applicata");
      } // Chiusura del nuovo blocco
      // Qui la variabile saldoConPenale non esiste pi
      // System.out.println(saldoConPenale); Errore! Simbolo non riconosciuto
      System.out.println("Nuovo Saldo = " + saldo + " euro");
    }
  }

  /** Ispeziona il valore del saldo attuale
      del conto bancario
      @return il saldo attuale
      */
  public double getBalance() {
    return saldo;
  }

  /** Penale applicata in caso di tentativo di prelievo senza
      disponibilit&agrave; */
  public static final double PENALTY = 5.0;

  // Variabile istanza
  private double saldo;
}
